﻿// Unicessing Rolling サンプル
// Written by NISHIDA Ryota, http://dev.eyln.com

using UnityEngine;
using Unicessing;

// 渦を巻く図形を描きます。
// インスペクタでDefault Depth Stepを0.0001など小さな値にしてください。
public class UnicessingRolling : UGraphics
{
    // 初期化
    protected override void Setup()
    {
        noLights(); // 塗りつぶしにライトを使わないようにする
    }

    // 毎フレームの更新と描画
    protected override void Draw()
    {
        textSize(0.2f);         // 文字の大きさ
        text("rolling", 0, 0);  // 文字を描く

        for (int i = 0; i < 500; i++)
        {
            rotate(i * 0.08f);  // 回転する
            scale(0.995f);      // 大きさを変える
            translate(0, sin(frameSec) * 0.2f); // 移動する
            fill(i / 2, i / 2, 255); // 色を設定
            rect(0, 0, 0.1f, 0.1f);  // 四角を描く
        }
    }
}
